/********************************************************************************
* pkgbuild an X Windows RPM(C) SPEC file developemnt system	                    *
* Copyright (C) 2000 by Davin S. Hills.  All Rights Reserved.                   *
*********************************************************************************
* This program is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Library General Public                   *
* License as published by the Free Software Foundation; either                  *
* version 2 of the License, or (at your option) any later version.              *
*                                                                               *
* This program is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             *
* Library General Public License for more details.                              *
*                                                                               *
* You should have received a copy of the GNU Library General Public             *
* License along with this library; if not, write to the Free                    *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            *
********************************************************************************/
#include "fx.h"
#include "advanced.h"
#include "inputdlg.h"
#include <string.h>

FXDEFMAP(AdvancedDlg) AdvancedDlgMap[]={
 	FXMAPFUNC(SEL_COMMAND,	AdvancedDlg::ID_D_ADD,		AdvancedDlg::onCmdAdd),
 	FXMAPFUNC(SEL_COMMAND,	AdvancedDlg::ID_D_DELETE,	AdvancedDlg::onCmdDelete),
 	FXMAPFUNC(SEL_UPDATE,	AdvancedDlg::ID_D_DELETE,	AdvancedDlg::onUpdDelete),
 	FXMAPFUNC(SEL_COMMAND,	AdvancedDlg::ID_D_EDIT,		AdvancedDlg::onCmdEdit),
 	FXMAPFUNC(SEL_UPDATE,	AdvancedDlg::ID_D_EDIT,		AdvancedDlg::onUpdEdit),
};

// AdvancedDlg implementation
FXIMPLEMENT(AdvancedDlg,FXDialogBox,AdvancedDlgMap,ARRAYNUMBER(AdvancedDlgMap))
	

// Construct a dialog box
AdvancedDlg::AdvancedDlg(FXApp *app): FXDialogBox(app,"Advanced Spec Settings",DECOR_TITLE|DECOR_BORDER)
{
	void *dum;
   	FXVerticalFrame *contents=new FXVerticalFrame(this,FRAME_THICK|LAYOUT_SIDE_TOP|LAYOUT_FILL_X|LAYOUT_FILL_Y);

	FXTabBook *tabbook=new FXTabBook(contents,NULL,0,LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_RIGHT);

	dum = (void*)new FXTabItem(tabbook,"&Preamble",NULL); //Tab 1
	FXVerticalFrame *t1vframe=new FXVerticalFrame(tabbook,LAYOUT_FILL_Y|LAYOUT_LEFT|PACK_UNIFORM_WIDTH|FRAME_THICK|FRAME_RAISED);
	FXMatrix *fields=new FXMatrix(t1vframe,2,MATRIX_BY_COLUMNS|LAYOUT_SIDE_TOP|LAYOUT_FILL_X|FRAME_GROOVE);
	//FXList *sourceX;
	//FXList *patchX;
	dum = (void*)new FXLabel(fields,"Distribution:",NULL,JUSTIFY_LEFT);
	distribution = new FXTextField(fields,25,this,ID_DISTRIBUTION,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"Vendor:",NULL,JUSTIFY_LEFT);
	vendor = new FXTextField(fields,25,this,ID_VENDOR,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"URL:",NULL,JUSTIFY_LEFT);
	url = new FXTextField(fields,25,this,ID_URL,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"Packager:",NULL,JUSTIFY_LEFT);
	packager = new FXTextField(fields,25,this,ID_PACKAGER,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"Provides:",NULL,JUSTIFY_LEFT);
	provides = new FXTextField(fields,25,this,ID_PROVIDES,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"Requires:",NULL,JUSTIFY_LEFT);
	requires = new FXTextField(fields,25,this,ID_REQUIRES,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"Prereq:",NULL,JUSTIFY_LEFT);
	prereq = new FXTextField(fields,25,this,ID_PREREQ,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"Serial:",NULL,JUSTIFY_LEFT);
	serial = new FXTextField(fields,25,this,ID_SERIAL,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"Auto Req Prov:",NULL,JUSTIFY_LEFT);
	autoreqprov = new FXTextField(fields,25,this,ID_AUTOREQPROV,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"Exclude Arch:",NULL,JUSTIFY_LEFT);
	excludearch = new FXTextField(fields,25,this,ID_EXCLUDEARCH,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"Exclusive Arch:",NULL,JUSTIFY_LEFT);
	exclusivearch = new FXTextField(fields,25,this,ID_EXCLUSIVEARCH,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"Exclude OS:",NULL,JUSTIFY_LEFT);
	excludeos = new FXTextField(fields,25,this,ID_EXCLUDEOS,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"Exclusive OS:",NULL,JUSTIFY_LEFT);
	exclusiveos = new FXTextField(fields,25,this,ID_EXCLUSIVEOS,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"Prefix:",NULL,JUSTIFY_LEFT);
	prefix = new FXTextField(fields,25,this,ID_PREFIX,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"BuildRoot:",NULL,JUSTIFY_LEFT);
	buildroot = new FXTextField(fields,25,this,ID_BUILDROOT,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"No Source:",NULL,JUSTIFY_LEFT);
	nosource = new FXTextField(fields,25,this,ID_NOSOURCE,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXLabel(fields,"No Patch:",NULL,JUSTIFY_LEFT);
	nopatch = new FXTextField(fields,25,this,ID_NOPATCH,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	
	
	dum = (void*)new FXTabItem(tabbook,"&Source X",NULL); //Tab 2
	FXVerticalFrame *sframe=new FXVerticalFrame(tabbook,FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_Y|LAYOUT_LEFT|PACK_UNIFORM_WIDTH);
	dum = (void*)new FXLabel(sframe,"Original source packages number 0 .. ?",NULL,JUSTIFY_LEFT|LAYOUT_FILL_X);
	FXHorizontalFrame *fsource = new FXHorizontalFrame(sframe,LAYOUT_FILL_Y|LAYOUT_FILL_X|FRAME_GROOVE);
	sourceX=new FXText(fsource,NULL,0,LAYOUT_FILL_X|LAYOUT_FILL_Y|FRAME_THICK|FRAME_SUNKEN);

	dum = (void*)new FXTabItem(tabbook,"&Patch X",NULL); //Tab 3
	FXVerticalFrame *pframe=new FXVerticalFrame(tabbook,FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_Y|LAYOUT_LEFT|PACK_UNIFORM_WIDTH);
	dum = (void*)new FXLabel(pframe,"Patches number 0 .. ?",NULL,JUSTIFY_LEFT|LAYOUT_FILL_X);
	FXHorizontalFrame *fpatch = new FXHorizontalFrame(pframe,LAYOUT_FILL_Y|LAYOUT_FILL_X|FRAME_GROOVE);
	patchX=new FXText(fpatch,NULL,0,LAYOUT_FILL_X|LAYOUT_FILL_Y|FRAME_THICK|FRAME_SUNKEN);

	dum = (void*)new FXTabItem(tabbook,"%define",NULL); //Tab 3
	FXVerticalFrame *dframe=new FXVerticalFrame(tabbook,FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_Y|LAYOUT_LEFT|PACK_UNIFORM_WIDTH);
	dum = (void*)new FXLabel(dframe,"%define: Text replacement macros.",NULL,JUSTIFY_LEFT|LAYOUT_FILL_X);
	FXHorizontalFrame *fbut = new FXHorizontalFrame(dframe,LAYOUT_FILL_X|PACK_UNIFORM_WIDTH|FRAME_GROOVE);
	dum = (void*)new FXButton(fbut,"&Add\t\tAdd new %define.",NULL,this,ID_D_ADD,BUTTON_TOOLBAR|FRAME_THICK|FRAME_RAISED);
	dum = (void*)new FXButton(fbut,"&Edit\t\tEdit current %define.",NULL,this,ID_D_EDIT,BUTTON_TOOLBAR|FRAME_THICK|FRAME_RAISED);
	dum = (void*)new FXButton(fbut,"&Delete\t\tDelete current %define.",NULL,this,ID_D_DELETE,BUTTON_TOOLBAR|FRAME_THICK|FRAME_RAISED);
	FXHorizontalFrame *fdefine = new FXHorizontalFrame(dframe,LAYOUT_FILL_Y|LAYOUT_FILL_X|FRAME_GROOVE);
	defines = new FXList(fdefine,1,NULL,0,LIST_SINGLESELECT|LAYOUT_FILL_X|LAYOUT_FILL_Y);
	
	FXHorizontalFrame *frame=new FXHorizontalFrame(contents,PACK_UNIFORM_WIDTH|LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X|LAYOUT_FILL_Y);
	dum = (void*)new FXButton(frame,"&Cancel\t\tDo not save Advanced changes.",NULL,this,ID_CANCEL,BUTTON_TOOLBAR|FRAME_RAISED|FRAME_THICK|LAYOUT_RIGHT|LAYOUT_CENTER_Y);
	dum = (void*)new FXButton(frame,"&OK\t\tSave changes to Advanced.",NULL,this,ID_ACCEPT,BUTTON_TOOLBAR|FRAME_RAISED|FRAME_THICK|LAYOUT_RIGHT|LAYOUT_CENTER_Y);
	dum = (void*)new FXButton(frame,"&Help\t\tGet help for Advanced settings.",NULL,this,ID_HELP,BUTTON_TOOLBAR|FRAME_RAISED|FRAME_THICK|LAYOUT_RIGHT|LAYOUT_CENTER_Y);
}

void AdvancedDlg::setData()
{
	distribution->setText(Adistribution);
	vendor->setText(Avendor);
	url->setText(Aurl);
	packager->setText(Apackager);
	provides->setText(Aprovides);
	requires->setText(Arequires);
	prereq->setText(Aprereq);
	serial->setText(Aserial);
	autoreqprov->setText(Aautoreqprov);
	excludearch->setText(Aexcludearch);
	exclusivearch->setText(Aexclusivearch);
	excludeos->setText(Aexcludeos);
	exclusiveos->setText(Aexclusiveos);
	prefix->setText(Aprefix);
	buildroot->setText(Abuildroot);
	nosource->setText(Anosource);
	nopatch->setText(Anopatch);
	sourceX->setText(AsourceX.text());
	patchX->setText(ApatchX.text());
	defines->clearItems();
	if (Adefines.length() > 0) {
		FXchar *tdefines;
		int i,z;
		i =  z = 0; 
		tdefines = new FXchar[Adefines.length()+1];
		memset(tdefines,0,Adefines.length());
		while (Adefines[i]) {
			if (Adefines[i] == '\n') {
				defines->appendItem(tdefines);
				memset(tdefines,0,Adefines.length());
				z=0;
			}
			else {
				tdefines[z++] = Adefines[i];
			}
			i++;
		}
		if (tdefines[0])
			defines->appendItem(tdefines);
		delete tdefines;
	}

}

void AdvancedDlg::commitData()
{
	Adistribution = distribution->getText();
	Avendor = vendor->getText();
	Aurl = url->getText();
	Apackager = packager->getText();
	Aprovides = provides->getText();
	Arequires = requires->getText();
	Aprereq = prereq->getText();
	Aserial = serial->getText();
	Aautoreqprov = autoreqprov->getText();
	Aexcludearch = excludearch->getText();
	Aexclusivearch = exclusivearch->getText();
	Aexcludeos = excludeos->getText();
	Aexclusiveos = exclusiveos->getText();
	Aprefix = prefix->getText();
	Abuildroot = buildroot->getText();
	Anosource = nosource->getText();
	Anopatch = nopatch->getText();
	AsourceX = sourceX->getText();
	ApatchX = patchX->getText();

	Adefines.clear();

	int i;
	for (i=0;i<defines->getNumItems();i++) 
		Adefines += FXString(defines->getItemText(i)) + "\n";
}

long AdvancedDlg::onCmdAdd(FXObject*,FXSelector,void*)
{
	InputDialog id(getApp());
	id.setTitle("Add %define");
	if (id.execute()) {
		defines->appendItem(id.input->getText());		
	}
	return 1;
}

long AdvancedDlg::onCmdDelete(FXObject*,FXSelector,void*)
{
	for (int i=0;i<defines->getNumItems();i++) {
		if (defines->isItemSelected(i)) {
			defines->removeItem(i);
			return 1;
		}
	}
	return 1;
}

long AdvancedDlg::onUpdDelete(FXObject *source,FXSelector,void*)
{
	for (int i=0;i<defines->getNumItems();i++) {
		if (defines->isItemSelected(i)) {
			((FXButton*)source)->enable();
			return 1;
		}
	}
	((FXButton*)source)->disable();
	return 1;
}

long AdvancedDlg::onCmdEdit(FXObject*,FXSelector,void*)
{
	for (int i=0;i<defines->getNumItems();i++) {
		if (defines->isItemSelected(i)) {
			InputDialog id(getApp());
			id.setTitle("Edit %define");
			id.input->setText(defines->getItemText(i));
			if (id.execute()) {
				defines->setItemText(i,id.input->getText());
			}
		}
	}
	return 1;
}

long AdvancedDlg::onUpdEdit(FXObject *source,FXSelector,void*)
{
	for (int i=0;i<defines->getNumItems();i++) {
		if (defines->isItemSelected(i)) {
			((FXButton*)source)->enable();
			return 1;
		}
	}
	((FXButton*)source)->disable();
	return 1;
}


