/********************************************************************************
* pkgbuild an X Windows RPM(C) SPEC file developemnt system	                    *
* Copyright (C) 2000 by Davin S. Hills.  All Rights Reserved.                   *
*********************************************************************************
* This program is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Library General Public                   *
* License as published by the Free Software Foundation; either                  *
* version 2 of the License, or (at your option) any later version.              *
*                                                                               *
* This program is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             *
* Library General Public License for more details.                              *
*                                                                               *
* You should have received a copy of the GNU Library General Public             *
* License along with this library; if not, write to the Free                    *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            *
********************************************************************************/
#include "fx.h"
#include "files.h"
#include <string.h>
#include <stdlib.h>

FXDEFMAP(FilesDlg) FilesDlgMap[]={
 	FXMAPFUNC(SEL_COMMAND,	FilesDlg::ID_BROWSE,	FilesDlg::onCmdBrowse),
 	FXMAPFUNC(SEL_COMMAND,	FilesDlg::ID_ACCEPT,	FilesDlg::onCmdAccept),
};

// FilesDlg implementation
FXIMPLEMENT(FilesDlg,FXDialogBox,FilesDlgMap,ARRAYNUMBER(FilesDlgMap))

// Construct a dialog box
FilesDlg::FilesDlg(FXApp *app): FXDialogBox(app,"Input Dialog",DECOR_TITLE|DECOR_BORDER)
{
	void *dum;
   	FXVerticalFrame *contents=new FXVerticalFrame(this,FRAME_RAISED|FRAME_THICK|LAYOUT_SIDE_TOP|LAYOUT_FILL_X|LAYOUT_FILL_Y);
	dum = (void*)new FXLabel(contents,"This should be the path to the  installed file."
									"\nNot the file in the BUILD directory.",NULL,JUSTIFY_CENTER_X|LAYOUT_FILL_X); 

	FXMatrix *fields=new FXMatrix(contents,2,MATRIX_BY_COLUMNS|LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
	input =	new FXTextField(fields,25,this,ID_INPUT,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXButton(fields," ... \tBrowse\tSearch for the file.",NULL,this,ID_BROWSE,FRAME_RAISED|FRAME_THICK|LAYOUT_CENTER_X);
	
	//FXMatrix *gframe=new FXMatrix(contents,3,PACK_UNIFORM_WIDTH|MATRIX_BY_COLUMNS|LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
	FXHorizontalFrame *gframe=new FXHorizontalFrame(contents,PACK_UNIFORM_HEIGHT|PACK_UNIFORM_WIDTH|LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X|LAYOUT_FILL_Y);
	FXVerticalFrame *vgframe=new FXVerticalFrame(gframe,PACK_UNIFORM_WIDTH|LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X|LAYOUT_FILL_Y);
	FXGroupBox *tgroup= new FXGroupBox(vgframe,"Type",LAYOUT_FILL_X|FRAME_RIDGE);
	rstd = new FXRadioButton(tgroup,"Default");
	rdoc = new FXRadioButton(tgroup,"%doc");
	rconfig = new FXRadioButton(tgroup,"%config");
	dum = (void*)new FXRadioButton(tgroup,"%config(missingok)");
	rdir = new FXRadioButton(tgroup,"%dir");
	dum = (void*)new FXRadioButton(tgroup,"%docdir");
	FXGroupBox *agroup = new FXGroupBox(vgframe,"Attr",LAYOUT_FILL_X|FRAME_RIDGE);
	dum = (void*)new FXCheckButton(agroup,"Default");
	FXMatrix *amatrix=new FXMatrix(agroup,2,MATRIX_BY_COLUMNS|LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
	dum = (void*)new FXCheckButton(amatrix,"mode:");
	dum = (void*)new FXTextField(amatrix,5,this,ID_INPUT,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXCheckButton(amatrix,"user:");
	dum = (void*)new FXTextField(amatrix,5,this,ID_INPUT,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	dum = (void*)new FXCheckButton(amatrix,"group:");
	dum = (void*)new FXTextField(amatrix,5,this,ID_INPUT,LAYOUT_FILL_COLUMN|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	FXGroupBox *vgroup = new FXGroupBox(gframe,"Verify",PACK_UNIFORM_HEIGHT|LAYOUT_FILL_Y|LAYOUT_FILL_X|FRAME_RIDGE);
	dum = (void*)new FXCheckButton(vgroup,"Default");
	dum = (void*)new FXCheckButton(vgroup,"owner");
	dum = (void*)new FXCheckButton(vgroup,"group");
	dum = (void*)new FXCheckButton(vgroup,"mode");
	dum = (void*)new FXCheckButton(vgroup,"md5");
	dum = (void*)new FXCheckButton(vgroup,"size");
	dum = (void*)new FXCheckButton(vgroup,"maj");
	dum = (void*)new FXCheckButton(vgroup,"min");
	dum = (void*)new FXCheckButton(vgroup,"symlink");
	dum = (void*)new FXCheckButton(vgroup,"mtime");
	
	dum = (void*)new FXHorizontalSeparator(contents,LAYOUT_SIDE_TOP|LAYOUT_FILL_X|SEPARATOR_GROOVE);
	FXHorizontalFrame *frame=new FXHorizontalFrame(contents,PACK_UNIFORM_WIDTH|LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X|LAYOUT_FILL_Y);
	dum = (void*)new FXButton(frame,"&Cancel\t\tDo not save save the file information.",NULL,this,ID_CANCEL,BUTTON_TOOLBAR|FRAME_RAISED|FRAME_THICK|LAYOUT_RIGHT|LAYOUT_CENTER_Y);
	dum = (void*)new FXButton(frame,"&OK\t\tSave the file information.",NULL,this,ID_ACCEPT,BUTTON_TOOLBAR|FRAME_RAISED|FRAME_THICK|LAYOUT_RIGHT|LAYOUT_CENTER_Y);
	dum = (void*)new FXButton(frame,"&Help\t\tGet help for files.",NULL,this,ID_HELP,BUTTON_TOOLBAR|FRAME_RAISED|FRAME_THICK|LAYOUT_RIGHT|LAYOUT_CENTER_Y);
}

void FilesDlg::setTitle(FXString title)
{
	this->handle(this,MKUINT(FXWindow::ID_SETSTRINGVALUE,SEL_COMMAND),(void*)&title);
	if (fname.length() && (fname[0] == '%')) {
		int i=0,z=0;
		char *tstr = strdup(fname.text());
		memset(tstr,0,fname.length());	
		while (fname[i] != ' ') tstr[z++] = fname[i++];
		if (!strcasecmp(tstr,"%doc"))
			rdoc->setCheck(TRUE);			
		else if (!strcasecmp(tstr,"%config"))
			rconfig->setCheck(TRUE);			
		else if (!strcasecmp(tstr,"%attr"))
			rattr->setCheck(TRUE);			
		else if (!strcasecmp(tstr,"%dir"))
			rdir->setCheck(TRUE);			
		else 
			i=-1,rstd->setCheck(TRUE);			
		free(tstr);
		fname = fname.mid(++i,fname.length());	
	}
	else {
		rstd->setCheck(TRUE);			
	}
	
	input->setText(fname);		
	input->setFocus();
}

long FilesDlg::onCmdBrowse(FXObject*, FXSelector, void*)
{
	FXString filename = "/usr/local/bin/*";
	FXFileDialog openDlg(this,"Browse File");
	openDlg.setFilename(filename);
	openDlg.setPattern("*");
	if(openDlg.execute()){
		input->setText(openDlg.getFilename());
	}

	return 1;
}

long FilesDlg::onCmdAccept(FXObject *source, FXSelector sel, void *ptr)
{
	if (rstd->getCheck())
		fname = input->getText();
	else if (rdoc->getCheck())
		fname = FXString("%doc ") + input->getText();	
	else if (rconfig->getCheck())
		fname = FXString("%config ") + input->getText();	
	else if (rattr->getCheck())
		fname = FXString("%attr ") + input->getText();	
	else if (rdir->getCheck())
		fname = FXString("%dir ") + input->getText();	
	return FXDialogBox::onCmdAccept(source,sel,ptr);
}

