/********************************************************************************
* pkgbuild an X Windows RPM(C) SPEC file developemnt system	                    *
* Copyright (C) 2000 by Davin S. Hills.  All Rights Reserved.                   *
*********************************************************************************
* This program is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Library General Public                   *
* License as published by the Free Software Foundation; either                  *
* version 2 of the License, or (at your option) any later version.              *
*                                                                               *
* This program is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             *
* Library General Public License for more details.                              *
*                                                                               *
* You should have received a copy of the GNU Library General Public             *
* License along with this library; if not, write to the Free                    *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            *
********************************************************************************/
#include "pkgbuild.h"
//#include "icons.h"
#include "inputdlg.h"
#include "files.h"
#include "advanced.h"
#include "script.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>

#ifndef PIPE_BUF
#define PIPE_BUF 5120
#endif

extern void clearLexStrings();
extern void	cleanLexStrings();
extern FXString l_app,l_ver,l_rel,l_sum,l_descrip,l_copyright,l_group;
extern FXString l_prep,l_build,l_install,l_post,l_files;
extern FXString l_release, l_distribution, l_icon, l_vendor, l_url, l_packager;
extern FXString l_provides, l_requires, l_serial, l_autoreqprov, l_excludearch;
extern FXString l_exclusivearch, l_excludeos, l_exclusiveos, l_prefix;
extern FXString l_buildroot, l_nosource, l_nopatch;
extern FXString l_clean, l_pre, l_preun, l_postun, l_verifyscript, l_changelog;
extern FXString l_package, l_prereq;
extern FXString l_sourceX, l_patchX, l_defines;
extern FILE *yyin,*yyout;
int yylex();

// Map
FXDEFMAP(MainWindow) MainWindowMap[]={
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_NEW,		MainWindow::onCmdNew),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_OPEN,		MainWindow::onCmdOpen),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_SAVEAS,		MainWindow::onCmdSaveAs),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_SAVE,		MainWindow::onCmdSave),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_EXIT,		MainWindow::onCmdExit),
 	FXMAPFUNC(SEL_COMMAND,	0,							MainWindow::onCmdExit),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_ABOUT,		MainWindow::onCmdAbout),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_PREPONLY,	MainWindow::onCmdPrepOnly),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_LISTCHECK,	MainWindow::onCmdListCheck),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_COMPILEONLY,MainWindow::onCmdCompileOnly),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_INSTALLONLY,MainWindow::onCmdInstallOnly),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_BINARYONLY,	MainWindow::onCmdBinaryOnly),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_BUILDALL,	MainWindow::onCmdBuildAll),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_TEST,		MainWindow::onCmdTest),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_FILE_ADD,	MainWindow::onCmdFileAdd),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_FILE_DELETE,MainWindow::onCmdFileDelete),
 	FXMAPFUNC(SEL_UPDATE,	MainWindow::ID_FILE_DELETE,MainWindow::onUpdFileDelete),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_FILE_EDIT,	MainWindow::onCmdFileEdit),
 	FXMAPFUNC(SEL_UPDATE,	MainWindow::ID_FILE_EDIT,	MainWindow::onUpdFileEdit),
 	FXMAPFUNC(SEL_UPDATE,	MainWindow::ID_TEST,		MainWindow::onUpdTest),
 	FXMAPFUNC(SEL_IO_READ,	MainWindow::ID_TRIGGER,	MainWindow::onCmdTrigger),
 	FXMAPFUNC(SEL_CHANGED,	MainWindow::ID_NAME,		MainWindow::onCmdChanged),
 	FXMAPFUNC(SEL_CHANGED,	MainWindow::ID_SUMMARY,	MainWindow::onCmdChanged),
 	FXMAPFUNC(SEL_CHANGED,	MainWindow::ID_VERSION,	MainWindow::onCmdChanged),
 	FXMAPFUNC(SEL_CHANGED,	MainWindow::ID_RELEASE,	MainWindow::onCmdChanged),
 	FXMAPFUNC(SEL_CHANGED,	MainWindow::ID_COPYRIGHT,	MainWindow::onCmdChanged),
 	FXMAPFUNC(SEL_CHANGED,	MainWindow::ID_ICON,		MainWindow::onCmdChanged),
	FXMAPFUNC(SEL_UPDATE,  	MainWindow::ID_TITLE,   	MainWindow::onUpdTitle),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_ADVANCED,	MainWindow::onCmdAdvanced),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_M_PREP, 	MainWindow::onCmdMPrep),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_M_BUILD,	MainWindow::onCmdMBuild),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_M_INSTALL,	MainWindow::onCmdMInstall),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_M_CLEAN,	MainWindow::onCmdMClean),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_M_PRE,		MainWindow::onCmdMPre),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_M_POST,		MainWindow::onCmdMPost),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_M_PREUN,	MainWindow::onCmdMPreun),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_M_POSTUN,	MainWindow::onCmdMPostun),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_M_CHANGELOG,MainWindow::onCmdMChangeLog),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_M_VERIFY,	MainWindow::onCmdMVerify),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_CLEARTAB,	MainWindow::onCmdClearTab),
 	FXMAPFUNC(SEL_COMMAND,	MainWindow::ID_CLEARALL,	MainWindow::onCmdClearAll),
};

// Object implementation
FXIMPLEMENT(MainWindow,FXMainWindow,MainWindowMap,ARRAYNUMBER(MainWindowMap))
	
MainWindow::MainWindow(FXApp *a) : 
		FXMainWindow(a,"Package Builder",NULL,NULL,DECOR_ALL,25,25,750,550)
{
	dirty = test = 0;
	
	// Main Window
  	setSelector(ID_TITLE);

	// Make menu bar
	menubar=new FXMenuBar(this,LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
	
	FXMenuPane *filemenu=new FXMenuPane(this);
	//new FXMenuCommand(filemenu,"&New\t\tStart a new RPM SPEC file.",
	//		new FXGIFIcon(getApp(),filenew),this,ID_NEW);
	new FXMenuCommand(filemenu,"&New\t\tStart a new RPM SPEC file.",
			NULL,this,ID_NEW);
	//new FXMenuCommand(filemenu,
	//		"&Open..\t\tOpen an existing RPM SPEC file.",
	//		new FXGIFIcon(getApp(),fileopen),this,ID_OPEN);
	new FXMenuCommand(filemenu,
			"&Open..\t\tOpen an existing RPM SPEC file.",
			NULL,this,ID_OPEN);
	//new FXMenuCommand(filemenu,
	//		"&Save\t\tSave the current RPM SPEC file.",
	//		new FXGIFIcon(getApp(),filesave),this,ID_SAVE);
	new FXMenuCommand(filemenu,
			"&Save\t\tSave the current RPM SPEC file.",
			NULL,this,ID_SAVE);
	//new FXMenuCommand(filemenu,
	//		"Save &As...\t\tSave the current RPM SPEC file to a different name",
	//		new FXGIFIcon(getApp(),filesaveas),this,ID_SAVEAS);
	new FXMenuCommand(filemenu,
			"Save &As...\t\tSave the current RPM SPEC file to a different name",
			NULL,this,ID_SAVEAS);
	new FXMenuSeparator(filemenu);
	new FXMenuCommand(filemenu,
			"E&xit\t\tExit pkgbuild",NULL,this,ID_EXIT);
	new FXMenuTitle(menubar,"&File",NULL,filemenu);
	FXMenuPane *editmenu=new FXMenuPane(this);
	new FXMenuCommand(editmenu,
			"Clear &Tab\t\tClears the current tab.",NULL,this,ID_CLEARTAB);
	new FXMenuCommand(editmenu,
			"Clear &All\t\tClears all SPEC data.",NULL,this,ID_CLEARALL);
	new FXMenuTitle(menubar,"&Edit",NULL,editmenu);
	FXMenuPane *scripts=new FXMenuPane(this);
	new FXMenuCommand(scripts,
			"Prep\t\tScript to prepare the source for a build.",
			NULL,this,ID_M_PREP);
	new FXMenuCommand(scripts,
			"Build\t\tScript to build the source.",NULL,this,ID_M_BUILD);
	new FXMenuCommand(scripts,
			"Install\t\tScript to install the package.",
			NULL,this,ID_M_INSTALL);
	new FXMenuCommand(scripts,
			"Clean\t\tScript to clean up after install.",NULL,this,ID_M_CLEAN);
	new FXMenuTitle(menubar,"&Scripts",NULL,scripts);
	FXMenuPane *advscripts=new FXMenuPane(this);
	new FXMenuCommand(advscripts,
			"Pre...\t\tScript that runs before install.",NULL,this,ID_M_PRE);
	new FXMenuCommand(advscripts,
			"Post...\t\tScript that runs after install.",NULL,this,ID_M_POST);
	new FXMenuCommand(advscripts,
			"Preun...\t\tScript that runs before uninstall.",
			NULL,this,ID_M_PREUN);
	new FXMenuCommand(advscripts,
			"Postun...\t\tScript that runs after uninstall.",
			NULL,this,ID_M_POSTUN);
	new FXMenuCommand(advscripts,
			"Change Log...\t\tList of changes to this SPEC file.",
			NULL,this,ID_M_CHANGELOG);
	new FXMenuCommand(advscripts,
			"Verify...\t\tScript run to verify package.",
			NULL,this,ID_M_VERIFY);
	new FXMenuCascade(scripts,"&Advanced",NULL,advscripts);
	FXMenuPane *buildmenu=new FXMenuPane(this);
	new FXMenuCommand(buildmenu,
			"&Prep only\t\tRuns just the %prep section.",
			NULL,this,ID_PREPONLY);
	new FXMenuCommand(buildmenu,
			"&List only\t\tChecks the files in %files.",
			NULL,this,ID_LISTCHECK);
	new FXMenuCommand(buildmenu,
			"&Compile only\t\tRuns %prep and compiles.",
			NULL,this,ID_COMPILEONLY);
	new FXMenuCommand(buildmenu,
			"&Install only\t\tRuns %prep, compiles, and installs.",
			NULL,this,ID_INSTALLONLY);
	new FXMenuCommand(buildmenu,
			"&Binary only\t\t%prep, compile, install, and build a "
			"binary package only.",NULL,this,ID_BINARYONLY);
	new FXMenuCommand(buildmenu,
			"Build &All\t\tBuilds both source and binary packages.",
			NULL,this,ID_BUILDALL);
	new FXMenuSeparator(buildmenu);
	new FXMenuCommand(buildmenu,"Test\t\tDoes not actually "
			"execute but keeps temp files.",NULL,this,ID_TEST);
	new FXMenuTitle(menubar,"&Build",NULL,buildmenu);
	FXMenuPane *helpmenu=new FXMenuPane(this);
	//new FXMenuCommand(helpmenu,"&User's Guide",NULL,this,ID_ABOUT,0);
	//new FXMenuCommand(helpmenu,"&Help for main window",
	//		NULL,this,ID_ABOUT,0);
	//new FXMenuCommand(helpmenu,
	//		"&About pkgbuild...\t\tShow About information for pkgbuild.",
	//		new FXGIFIcon(getApp(),penguin),this,ID_ABOUT,0);
	new FXMenuCommand(helpmenu,
			"&About pkgbuild...\t\tShow About information for pkgbuild.",
			NULL,this,ID_ABOUT,0);
	new FXMenuTitle(menubar,"&Help",NULL,helpmenu);

   	// Status bar
  	statusbar=new FXStatusbar(this,LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X|
			STATUSBAR_WITH_DRAGCORNER);

	// Separator
	new FXHorizontalSeparator(this,LAYOUT_SIDE_TOP|
			LAYOUT_FILL_X|SEPARATOR_GROOVE);
	
	// Contents
	FXVerticalFrame *contents=new FXVerticalFrame(this,LAYOUT_SIDE_TOP|
			FRAME_NONE|LAYOUT_FILL_X|LAYOUT_FILL_Y);

	// Switcher
	tabbook=new FXTabBook(contents,NULL,0,
			LAYOUT_FILL_X|LAYOUT_FILL_Y);

	// Tab 1 is the Header section
	new FXTabItem(tabbook,"Preamble",NULL);
	FXVerticalFrame *t1vframe=new FXVerticalFrame(tabbook,
			LAYOUT_FILL_Y|LAYOUT_FILL_X|
			LAYOUT_LEFT|PACK_UNIFORM_WIDTH|FRAME_THICK|FRAME_RAISED);
	//Matrix Layout for required
	FXMatrix *t1fields=new FXMatrix(t1vframe,4,MATRIX_BY_COLUMNS|
			LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
	new FXLabel(t1fields,"Name:",NULL,JUSTIFY_LEFT);
	name=new FXTextField(t1fields,25,this,ID_NAME,LAYOUT_FILL_COLUMN|
			LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	new FXLabel(t1fields,"Version:",NULL,JUSTIFY_LEFT);
	version=new FXTextField(t1fields,25,this,ID_VERSION,LAYOUT_FILL_COLUMN|
			LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	new FXLabel(t1fields,"Release:   ",NULL,JUSTIFY_LEFT);
	release=new FXTextField(t1fields,25,this,ID_RELEASE,LAYOUT_FILL_COLUMN|
			LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	new FXLabel(t1fields,"Copyright:",NULL,JUSTIFY_LEFT);
	copyright=new FXTextField(t1fields,25,this,ID_COPYRIGHT,LAYOUT_FILL_COLUMN|
			LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	new FXLabel(t1fields,"Group:",NULL,JUSTIFY_LEFT);
	group=new FXComboBox(t1fields,0,25,this,ID_GROUP,LAYOUT_FILL_COLUMN|
			LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	new FXLabel(t1fields,"Summary:",NULL,JUSTIFY_LEFT);
	summary=new FXTextField(t1fields,25,this,ID_SUMMARY,LAYOUT_FILL_COLUMN|
			LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	new FXLabel(t1fields,"Source0:",NULL,JUSTIFY_LEFT);
	source=new FXTextField(t1fields,25,this,ID_GROUP,LAYOUT_FILL_COLUMN|
			LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	new FXLabel(t1fields,"Icon:",NULL,JUSTIFY_LEFT);
	icon=new FXTextField(t1fields,25,this,ID_ICON,LAYOUT_FILL_COLUMN|
			LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK);
	new FXLabel(t1vframe,"Description:",NULL,JUSTIFY_LEFT|
			LAYOUT_FILL_X);
	FXHorizontalFrame *fdescrip = new FXHorizontalFrame(t1vframe,
			LAYOUT_FILL_Y|LAYOUT_FILL_X|FRAME_GROOVE);
	description = new FXText(fdescrip,NULL,0,LAYOUT_FILL_X|LAYOUT_FILL_Y|
			FRAME_THICK|FRAME_SUNKEN);
	new FXButton(t1vframe,"&Advanced\t\tAdvanced preamble options.",
			NULL,this,ID_ADVANCED,BUTTON_TOOLBAR|FRAME_THICK|FRAME_RAISED|
			LAYOUT_RIGHT|LAYOUT_SIDE_RIGHT|LAYOUT_FIX_WIDTH,0,0,75);
	
	// Tab 2 Prep and Build 
	new FXTabItem(tabbook,"Prep and Build",NULL);
	FXVerticalFrame *t2vframe=new FXVerticalFrame(tabbook,
			LAYOUT_FILL_Y|LAYOUT_FILL_X|
			LAYOUT_LEFT|FRAME_THICK|FRAME_RAISED);
	new FXLabel(t2vframe,"%prep: Script to prepare for building.",
			NULL,JUSTIFY_LEFT|LAYOUT_FILL_X);
	FXHorizontalFrame *fpreps = new FXHorizontalFrame(t2vframe,LAYOUT_FILL_Y|
			LAYOUT_FILL_X|FRAME_GROOVE);
	prep_s = new FXText(fpreps,NULL,0,LAYOUT_FILL_X|LAYOUT_FILL_Y|FRAME_THICK|
			FRAME_SUNKEN);
	new FXLabel(t2vframe,"%build: Script to build the package.",
			NULL,JUSTIFY_LEFT|LAYOUT_FILL_X);
	FXHorizontalFrame *fbuilds = new FXHorizontalFrame(t2vframe,LAYOUT_FILL_Y|
			LAYOUT_FILL_X|FRAME_GROOVE);
	build_s = new FXText(fbuilds,NULL,0,LAYOUT_FILL_X|LAYOUT_FILL_Y|FRAME_THICK|
			FRAME_SUNKEN);
			
	// Tab 3 Install and Clean
	new FXTabItem(tabbook,"Install and Clean",NULL);
	FXVerticalFrame *t3vframe=new FXVerticalFrame(tabbook,LAYOUT_FILL_Y|
			LAYOUT_LEFT|FRAME_THICK|FRAME_RAISED);
	new FXLabel(t3vframe,"%install: Script to install the package.",
			NULL,JUSTIFY_LEFT|LAYOUT_FILL_X);
	FXHorizontalFrame *finstalls = new FXHorizontalFrame(t3vframe,LAYOUT_FILL_Y|
			LAYOUT_FILL_X|FRAME_GROOVE);
	install_s=new FXText(finstalls,NULL,0,LAYOUT_FILL_X|LAYOUT_FILL_Y|
			FRAME_THICK|FRAME_SUNKEN);
	new FXLabel(t3vframe,"%clean: Script to clean up after install.",
			NULL,JUSTIFY_LEFT|LAYOUT_FILL_X);
	FXHorizontalFrame *fcleans = new FXHorizontalFrame(t3vframe,LAYOUT_FILL_Y|
			LAYOUT_FILL_X|FRAME_GROOVE);
	clean_s=new FXText(fcleans,NULL,0,LAYOUT_FILL_X|LAYOUT_FILL_Y|FRAME_THICK|
			FRAME_SUNKEN);

	// Tab 4 Files
	new FXTabItem(tabbook,"Files",NULL);
	FXVerticalFrame *fileframe=new FXVerticalFrame(tabbook,FRAME_THICK|
			FRAME_RAISED|LAYOUT_FILL_Y|LAYOUT_LEFT);
	new FXLabel(fileframe,"%files: The file list for this package.",
			NULL,JUSTIFY_LEFT|LAYOUT_FILL_X);
	FXHorizontalFrame *fbut = new FXHorizontalFrame(fileframe,LAYOUT_FILL_X|
			PACK_UNIFORM_WIDTH|FRAME_GROOVE);
	new FXButton(fbut,"Add\t\tAdd a file name to the files list.",
			NULL,this,ID_FILE_ADD,BUTTON_TOOLBAR|FRAME_THICK|FRAME_RAISED);
	new FXButton(fbut,"Edit\t\tEdit the current file name.",
			NULL,this,ID_FILE_EDIT,BUTTON_TOOLBAR|FRAME_THICK|FRAME_RAISED);
	new FXButton(fbut,"Delete\t\tDelete the current file name.",
			NULL,this,ID_FILE_DELETE,BUTTON_TOOLBAR|FRAME_THICK|FRAME_RAISED);
	FXHorizontalFrame *flist = new FXHorizontalFrame(fileframe,LAYOUT_FILL_Y|
			LAYOUT_FILL_X|FRAME_GROOVE);
	filelist=new FXList(flist,1,NULL,0,LIST_SINGLESELECT|LAYOUT_FILL_X|LAYOUT_FILL_Y);

	// Tab 5 Build
	new FXTabItem(tabbook,"Build Package!",NULL);
	FXVerticalFrame *cframe=new FXVerticalFrame(tabbook,LAYOUT_FILL_Y|
			LAYOUT_LEFT|FRAME_THICK|FRAME_RAISED);
	FXHorizontalFrame *fbut2 = new FXHorizontalFrame(cframe,LAYOUT_FILL_X|
			FRAME_GROOVE|PACK_UNIFORM_WIDTH);
	new FXButton(fbut2,"Prep only\t\tRuns just the %prep section.",
			NULL,this,ID_PREPONLY,BUTTON_TOOLBAR|FRAME_THICK|FRAME_RAISED);
	new FXButton(fbut2,"List only\t\tChecks the files in %files.",
			NULL,this,ID_LISTCHECK,BUTTON_TOOLBAR|FRAME_THICK|FRAME_RAISED);
	new FXButton(fbut2,"Compile only\t\tRuns %prep and compiles.",
			NULL,this,ID_COMPILEONLY,BUTTON_TOOLBAR|FRAME_THICK|FRAME_RAISED);
	new FXButton(fbut2,"Install only\t\tRuns %prep, compiles, "
			"and installs.",NULL,this,ID_INSTALLONLY,BUTTON_TOOLBAR|
			FRAME_THICK|FRAME_RAISED);
	new FXButton(fbut2,"Binary only\t\t%prep, compile, install, "
			"and build a binary package only.",NULL,this,ID_BINARYONLY,
			BUTTON_TOOLBAR|FRAME_THICK|FRAME_RAISED);
	new FXButton(fbut2,"Build All\t\tBuilds both source and "
			"binary packages.",NULL,this,ID_BUILDALL,BUTTON_TOOLBAR|
			FRAME_THICK|FRAME_RAISED);
	FXHorizontalFrame *fbuild = new FXHorizontalFrame(cframe,
			LAYOUT_FILL_Y|LAYOUT_FILL_X|FRAME_GROOVE);
    buildbox=new FXText(fbuild,NULL,ID_RESPONSE,LAYOUT_FILL_Y|
			LAYOUT_FILL_X|TEXT_READONLY);

	advdlg = new AdvancedDlg(getApp());
	scriptDlg = new ScriptDlg(getApp());
	
	new FXTooltip(getApp(),0);
}

void MainWindow::create(){
	FXMainWindow::create();
	show();
	fillGroups();
	handle(this,MKUINT(MainWindow::ID_NEW,SEL_COMMAND),NULL);
}

long MainWindow::onCmdExit(FXObject*,FXSelector,void*)
{
	FXuint answer;
	if(dirty){
		answer = FXMessageBox::question(this,MBOX_YES_NO_CANCEL,
				"Unsaved SPEC","Save current SPEC to file?");
		if(answer==MBOX_CLICKED_CANCEL) 
			return 1;
		if(answer==MBOX_CLICKED_YES){
			if(curSpec.length() < 1){
				FXFileDialog save(this,"Save SPEC");
				if(save.execute()){
					if(fxexists(save.getFilename().text())){
						if(MBOX_CLICKED_NO==FXMessageBox::question(this,MBOX_YES_NO, 
									"Overwrite SPEC","Overwrite existing SPEC file?.")){
							return 1;
						}
					}
					curSpec=save.getFilename();
				}
				else {
					return 1;
				}
			}
			saveFile();
		}
	}

	exit(0);
	return 1;
}

long MainWindow::onCmdNew(FXObject*,FXSelector,void*)
{
	FXuint answer;
	if(dirty){
		answer=FXMessageBox::question(this,MBOX_YES_NO_CANCEL,"Unsaved SPEC", "Save current SPEC to file?");
		if(answer==MBOX_CLICKED_CANCEL) 
			return 1;
		if(answer==MBOX_CLICKED_YES){
			if(curSpec.length() < 1){
				FXFileDialog save(this,"Save SPEC");
				if(save.execute()){
					if(fxexists(save.getFilename().text())){
						if(MBOX_CLICKED_NO==FXMessageBox::question(this,MBOX_YES_NO, "Overwrite SPEC","Overwrite existing SPEC file?.")){
							return 1;
						}
					}
					curSpec=save.getFilename();
				}
				else {
					return 1;
				}
			}
			saveFile();
		}
	}

	FILE *file;
	clearLexStrings();
	char *home = getenv("HOME");
	FXString fxhome(home);
	if (fxhome.length() > 1) {
		if (fxhome[fxhome.length()] != '/')
			fxhome += "/";
		fxhome += ".newspec.spec";
		file = fopen(fxhome.text(),"r");
		if (file) {
			yyin = file;
			yylex();
			fclose(file);
		}
	}
	LoadSpecData();
	curSpec.clear();
	setClean();
	return 1;
}

long MainWindow::onCmdOpen(FXObject*,FXSelector,void*)
{
	FXuint answer;
	if(dirty){
		answer=FXMessageBox::question(this,MBOX_YES_NO_CANCEL,"Unsaved SPEC", "Save current SPEC to file?");
		if(answer==MBOX_CLICKED_CANCEL) 
			return 1;
		if(answer==MBOX_CLICKED_YES){
			if(curSpec.length() < 1){
				FXFileDialog save(this,"Save SPEC");
				if(save.execute()){
					if(fxexists(save.getFilename().text())){
						if(MBOX_CLICKED_NO==FXMessageBox::question(this,MBOX_YES_NO, "Overwrite SPEC","Overwrite existing SPEC file?.")){
							return 1;
						}
					}
					curSpec=save.getFilename();
				}
				else {
					return 1;
				}
			}
			saveFile();
		}
	}


	
	FXString filename = "/usr/src/redhat/SPECS/*";
	FXFileDialog openDlg(this,"Open Document");
	openDlg.setFilename(filename);
	openDlg.setPattern("*.spec");
	if(openDlg.execute()){
		filename=openDlg.getFilename();
		FILE *file;
		file = fopen(filename.text(),"r");
		if (!file) {
			fprintf(stderr,"Failed to open file\n");
			return 1;			
		}
		curSpec = filename;
		clearLexStrings();
		yyin = file;
		yylex();
		fclose(file);
		LoadSpecData();
		setClean();		
	}

	return 1;
}

int MainWindow::saveFile()
{
	FXString spec;
	spec = BuildSpecString();

	FILE *fd;	
	if ((fd = fopen(curSpec.text(),"w")) == NULL) {
		FXMessageBox::information(this,MBOX_OK,"Save Fail",
				"Failed to save spec file.");
		return 0;
	}
	if (!fwrite(spec.text(),sizeof(char),spec.length(),fd)) {
		if (ferror(fd)) {
			FXMessageBox::information(this,MBOX_OK,"Save Fail",
				"Failed to save spec file.");
			return 0;
		}
	}
	fclose(fd);
	return 1;
}

long MainWindow::onCmdSave(FXObject*,FXSelector,void*)
{
	if (curSpec.length() < 1) {
		this->handle(this,MKUINT(MainWindow::ID_SAVEAS,SEL_COMMAND),NULL);
		return 1;
	}
	if (saveFile())
		setClean();
	return 1;
}

long MainWindow::onCmdSaveAs(FXObject*,FXSelector,void*)
{
	FXString filename = "/usr/src/redhat/SPECS/";
   	filename += FXString(name->getText()) + "-" + version->getText() + ".spec";
	FXFileDialog openDlg(this,"Save Document");
	openDlg.setFilename(filename);
	openDlg.setPattern("*.spec");
	if(openDlg.execute()) {
		filename=openDlg.getFilename();
		if(fxexists(filename.text())){
			if(MBOX_CLICKED_NO==FXMessageBox::question(this,MBOX_YES_NO, "Overwrite SPEC","Overwrite existing SPEC file?.")) {
				return 1;
			}
		}
		FXString holdName;
		holdName = curSpec;
		curSpec = filename;
		if (!saveFile()) {
			curSpec = holdName;
			setClean();
		}
	}
	return 1;
}

FXString MainWindow::BuildSpecString()
{
	FXString spec;
	if (!summary->getText().empty())
		spec += "Summary: " + summary->getText() + "\n";
	if (!name->getText().empty())
		spec += "Name: " + name->getText() + "\n";
	//%define
	int i = 0, z=0, cnt = 0, len;
	
	FXString tstr;	
	if (advdlg->Adefines.length()) {
		len = advdlg->Adefines.length();
		len++;
		FXchar *tsource;
		tsource = new FXchar[len];
		memset(tsource,0,len);
		while (advdlg->Adefines[i]) {
			if (advdlg->Adefines[i] == '\n') {
				tstr.format("%%define %s\n",tsource);
				spec += tstr;
				memset(tsource,0,len);
				z=0;
			}
			else {
				tsource[z++] = advdlg->Adefines[i];
			}
			i++;
		}
		if (tsource[0]) {
			tstr.format("%%define %s\n",tsource);
			spec += tstr;
		}
		delete tsource;
	}
	
	if (!version->getText().empty())
		spec += FXString("Version: ") + version->getText() + "\n";
	if (!release->getText().empty())
		spec += FXString("Release: ") + release->getText() + "\n";
	if (!copyright->getText().empty())
		spec += FXString("Copyright: ") + copyright->getText() + "\n";
	if (!group->getText().empty())
		spec += FXString("Group: ") + group->getText() + "\n";
	if (!icon->getText().empty())
		spec += FXString("Icon: ") + icon->getText() +  "\n";

	//Add source0 to list
	int pos;
	if ((pos = advdlg->AsourceX.findf('\n')) == -1) //This is the only source
		advdlg->AsourceX = source->getText();
	else //multiple source use "source" as Source0
		advdlg->AsourceX = source->getText() + 
			advdlg->AsourceX.mid(pos,advdlg->AsourceX.length());

	//Source0 - ?	
	i = 0, z=0, cnt = 0;
	if (advdlg->AsourceX.length()) {
		len = advdlg->AsourceX.length();
		len++;
		FXchar *tsource;
		tsource = new FXchar[len];
		memset(tsource,0,len);
		while (advdlg->AsourceX[i]) {
			if (advdlg->AsourceX[i] == '\n') {
				tstr.format("Source%i: %s\n",cnt++,tsource);
				spec += tstr;
				memset(tsource,0,len);
				z=0;
			}
			else {
				tsource[z++] = advdlg->AsourceX[i];
			}
			i++;
		}
		if (tsource[0]) {
			tstr.format("Source%i: %s\n",cnt++,tsource);
			spec += tstr;
		}
		delete tsource;
	}
	//Patch0 - ?
	i = 0, z=0, cnt = 0;
	if (advdlg->ApatchX.length()) {
		len = advdlg->ApatchX.length();
		len++;
		FXchar *tsource;
		tsource = new FXchar[len];
		memset(tsource,0,len);
		while (advdlg->ApatchX[i]) {
			if (advdlg->ApatchX[i] == '\n') {
				tstr.format("Patch%i: %s\n",cnt++,tsource);
				spec += tstr;
				memset(tsource,0,len);
				z=0;
			}
			else {
				tsource[z++] = advdlg->ApatchX[i];
			}
			i++;
		}
		if (tsource[0]) {
			tstr.format("Patch%i: %s\n",cnt++,tsource);
			spec += tstr;
		}
		delete tsource;
	}
	//Advanced -----------
	if (advdlg->Adistribution.length())
		spec += FXString("Distribution: ") + advdlg->Adistribution + "\n";
	if (advdlg->Avendor.length())
		spec += FXString("Vendor: ") + advdlg->Avendor + "\n";
	if (advdlg->Aurl.length())
		spec += FXString("Url: ") + advdlg->Aurl + "\n";
	if (advdlg->Apackager.length())
		spec += FXString("Packager: ") + advdlg->Apackager + "\n";
	if (advdlg->Aprovides.length())
		spec += FXString("Provides: ") + advdlg->Aprovides + "\n";
	if (advdlg->Arequires.length())
		spec += FXString("Requires: ") + advdlg->Arequires + "\n";
	if (advdlg->Aprereq.length())
		spec += FXString("Prereq: ") + advdlg->Aprereq + "\n";
	if (advdlg->Aserial.length())
		spec += FXString("Serial: ") + advdlg->Aserial + "\n";
	if (advdlg->Aautoreqprov.length())
		spec += FXString("Autoreqprov: ") + advdlg->Aautoreqprov + "\n";
	if (advdlg->Aexcludearch.length())
		spec += FXString("Excludearch: ") + advdlg->Aexcludearch + "\n";
	if (advdlg->Aexclusivearch.length())
		spec += FXString("Excludeos: ") + advdlg->Aexclusivearch + "\n";
	if (advdlg->Aexcludeos.length())
		spec += FXString("Excludeos: ") + advdlg->Aexcludeos + "\n";
	if (advdlg->Aexclusiveos.length())
		spec += FXString("Exclusiveos: ") + advdlg->Aexclusiveos + "\n";
	if (advdlg->Aprefix.length())
		spec += FXString("Prefix: ") + advdlg->Aprefix + "\n";
	if (advdlg->Abuildroot.length())
		spec += FXString("Buildroot: ") + advdlg->Abuildroot + "\n";
	if (advdlg->Anosource.length())
		spec += FXString("NoSource: ") + advdlg->Anosource + "\n";
	if (advdlg->Anopatch.length())
		spec += FXString("Nopatch: ") + advdlg->Anopatch + "\n";
	// ----------------------
	if (description->getText().length())
		spec += FXString("\n%description\n") + description->getText() +  "\n";
	if (changelog.length()) 
		spec += FXString("\n%changelog\n") + changelog +  "\n";
	if (prep_s->getText().length())
		spec += FXString("\n%prep\n") + prep_s->getText() +  "\n";
	if (build_s->getText().length())
		spec += FXString("\n%build\n") + build_s->getText() +  "\n";
	if (install_s->getText().length())
		spec += FXString("\n%install\n") + install_s->getText() +  "\n";
	if (clean_s->getText().length())
		spec += FXString("\n%clean\n") + clean_s->getText() +  "\n";
	if (verify_s.length())
		spec += FXString("\n%verifyscript\n") + verify_s +  "\n";
	if (pre_s.length())
		spec += FXString("\n%pre\n") + pre_s +  "\n";
	if (post_s.length())
		spec += FXString("\n%post\n") + post_s +  "\n";
	if (preun_s.length())
		spec += FXString("\n%preun\n") + preun_s +  "\n";
	if (postun_s.length())
		spec += FXString("\n%postun\n") + postun_s +  "\n";
	/*
	FXListItem *item;
	item = filelist->getFirstItem();
	if (item != NULL) {
		spec += FXString("\n%files\n") + filelist->getItemText(item) + "\n";
		while ((item=filelist->getNextItem(item)) != NULL) {
			spec += FXString(filelist->getItemText(item)) + "\n";
		}
	}
	*/
	int num = filelist->getNumItems();
	if (num)
		spec += "\n%files\n";
	for (i=0;i<num;i++)
		spec += filelist->retrieveItem(i)->getText() + "\n";

	return spec;
}

void MainWindow::LoadSpecData()
{
	cleanLexStrings();
	summary->setText(l_sum);
	name->setText(l_app);
	version->setText(l_ver);
	release->setText(l_rel);
	copyright->setText(l_copyright);
	group->setText(l_group);
	int pos;
	if ((pos = l_sourceX.findf('\n')) == -1)
		source->setText(l_sourceX);
	else
		source->setText(l_sourceX.left(pos));
	icon->setText(l_icon);
	description->setText(l_descrip.text());
	filelist->clearItems();
	// l_files += l_doc + l_config + l_dir;
	int i = 0, z=0;
	if (l_files.length() > 0) {
		FXchar *tfile;
		tfile = new FXchar[l_files.length()+1];
		memset(tfile,0,l_files.length());
		while (l_files[i]) {
			if (l_files[i] == '\n') {
				filelist->appendItem(tfile);
				memset(tfile,0,l_files.length());
				z=0;
			}
			else {
				tfile[z++] = l_files[i];
			}
			i++;
		}
		if (tfile[0])
			filelist->appendItem(tfile);
		delete tfile;
	}
	//FXString theprep = l_prep + l_setup + l_patch;
	prep_s->setText(l_prep.text());
	build_s->setText(l_build.text());
	install_s->setText(l_install.text());
	clean_s->setText(l_clean.text());
	pre_s = l_pre;
	post_s = l_post;
	preun_s = l_preun;
	postun_s = l_postun;
	changelog = l_changelog;
	verify_s = l_verifyscript;
	
	//Advanced 
	advdlg->Adistribution = l_distribution;
	advdlg->Avendor = l_vendor;
	advdlg->Aurl = l_url;
	advdlg->Apackager = l_packager;
	advdlg->Aprovides = l_provides;
	advdlg->Arequires = l_requires;
	advdlg->Aprereq = l_prereq;
	advdlg->Aserial = l_serial;
	advdlg->Aautoreqprov = l_autoreqprov;
	advdlg->Aexcludearch = l_excludearch;
	advdlg->Aexclusivearch = l_exclusivearch;
	advdlg->Aexcludeos = l_excludeos;
	advdlg->Aexclusiveos = l_exclusiveos;
	advdlg->Aprefix = l_prefix;
	advdlg->Abuildroot = l_buildroot;
	advdlg->Anosource = l_nosource;
	advdlg->Anopatch = l_nopatch;
	advdlg->AsourceX = l_sourceX;
	advdlg->ApatchX = l_patchX;
	advdlg->Adefines = l_defines;
	clearLexStrings();

}

long MainWindow::onCmdAbout(FXObject*,FXSelector,void*)
{
	FXMessageBox::information(this,MBOX_OK,"About pkgbuild",
			"pkgbuild 0.1\n"
			"The RPM builder\n"
			"Davin S. Hills\n"
			"dshills@uswest.net\n"
			"http://www.users.uswest.net/~dshills/linux.html");
	return 1;
}

long MainWindow::onCmdPrepOnly(FXObject *sender,FXSelector,void *ptr)
{
	tabbook->handle(this,MKUINT(FXTabBar::ID_OPEN_FIRST+4,SEL_COMMAND),ptr);
	RunRPM_BuildCmd("rpm -bp -v ");
	return 1;
}

long MainWindow::onCmdListCheck(FXObject *sender,FXSelector,void *ptr)
{
	tabbook->handle(this,MKUINT(FXTabBar::ID_OPEN_FIRST+4,SEL_COMMAND),ptr);
	RunRPM_BuildCmd("rpm -bl -v ");
	return 1;
}

long MainWindow::onCmdCompileOnly(FXObject *sender,FXSelector,void *ptr)
{
	tabbook->handle(this,MKUINT(FXTabBar::ID_OPEN_FIRST+4,SEL_COMMAND),ptr);
	RunRPM_BuildCmd("rpm -bc -v ");
	return 1;
}

long MainWindow::onCmdInstallOnly(FXObject *sender,FXSelector,void *ptr)
{
	tabbook->handle(this,MKUINT(FXTabBar::ID_OPEN_FIRST+4,SEL_COMMAND),ptr);
	RunRPM_BuildCmd("rpm -bi -v ");
	return 1;
}

long MainWindow::onCmdBinaryOnly(FXObject *sender,FXSelector,void *ptr)
{
	tabbook->handle(this,MKUINT(FXTabBar::ID_OPEN_FIRST+4,SEL_COMMAND),ptr);
	RunRPM_BuildCmd("rpm -bb -v ");
	return 1;
}

long MainWindow::onCmdBuildAll(FXObject *sender,FXSelector,void *ptr)
{
	tabbook->handle(this,MKUINT(FXTabBar::ID_OPEN_FIRST+4,SEL_COMMAND),ptr);
	RunRPM_BuildCmd("rpm -ba -v ");
	return 1;
}

void MainWindow::RunRPM_BuildCmd(FXString cmd)
{
	FXuint answer;
	if(dirty){
		answer=FXMessageBox::question(this,MBOX_YES_NO_CANCEL,"Unsaved SPEC", 
				"Save SPEC before build?");
		if(answer==MBOX_CLICKED_CANCEL) 
			return ;
		if(answer==MBOX_CLICKED_YES){
			if(curSpec.length() < 1){
				FXFileDialog save(this,"Save SPEC");
				if(save.execute()){
					if(fxexists(save.getFilename().text())){
						if(MBOX_CLICKED_NO==FXMessageBox::question(this,MBOX_YES_NO, "Overwrite SPEC","Overwrite existing SPEC file?.")){
							return ;
						}
					}
					curSpec=save.getFilename();
				}
				else {
					return ;
				}
			}
			saveFile();
		}
	}

	if (curSpec.length() < 1) {
		buildbox->setText("No spec file loaded.");
		return ;
	}
	if (test)
		cmd += " --test ";
	
	cmd = cmd + curSpec;
	//int fdout[2];
	int rc = 0;
	
	
	fflush(stdout);
	fflush(stderr);

	if ((pipe(fdout) < 0) || ((rc = fork()) < 0))
		return ;			// couldn't pipe or fork 

	if (!rc) { //Child process
		freopen("/dev/null","r+",stdin); //close stdin 

		close(fileno(stdout));
		close(fileno(stderr));
		fcntl(fdout[1], F_DUPFD, fileno(stderr));
		fcntl(fdout[1], F_DUPFD, fileno(stdout));
		fcntl(fdout[1], F_SETFL, O_NONBLOCK);
		close(fdout[0]);
		close(fdout[1]);
		execl("/bin/sh","sh","-c",cmd.text(),(char*)0);

		// failed; avoid "atexit" 
		perror(cmd.text());
		kill(getpid(),SIGKILL);
	}
	
	else {
		buildbox->setText("");
		close(fdout[1]);
		getApp()->addInput(fdout[0],INPUT_READ,this,ID_TRIGGER);
	}

}

void MainWindow::fillGroups()
{
	FILE *file;
	clearLexStrings();
	char *home = getenv("HOME");
	FXString fxhome(home);
	if (fxhome.length() > 1) {
		if (fxhome[fxhome.length()] != '/')
			fxhome += "/";
		fxhome += ".groups";
		file = fopen(fxhome.text(),"r");
		if (file) { 
			char buffer[BUFSIZ + 1];
			memset(buffer,'\0',sizeof(buffer));
			while (fscanf(file,"%s\n",buffer) != EOF) {
				group->appendItem(buffer);
			}
			fclose(file);
		}
	}
}


long MainWindow::onCmdTest(FXObject*,FXSelector,void*)
{
	test = !test;
	return 1;
}

long MainWindow::onUpdTest(FXObject *source,FXSelector,void*)
{
	if (test)
		((FXMenuCommand*)source)->check();
	else
		((FXMenuCommand*)source)->uncheck();
	return 1;
}

long MainWindow::onCmdTrigger(FXObject*,FXSelector,void*)
{
	static FXString retstr;
	int res;
	char buffer[PIPE_BUF];
	memset(buffer,0,PIPE_BUF);
	res = read(fdout[0],buffer,PIPE_BUF);
	retstr += buffer;
	//buildbox->appendText(buffer,strlen(buffer));
	buildbox->setText(retstr.text());
	buildbox->makePositionVisible(retstr.length());
	if (res < 1) {
		getApp()->removeInput(fdout[0],INPUT_READ);
		close(fdout[0]);
		retstr.clear();
	}
	return 1;
}

long MainWindow::onCmdChanged(FXObject*,FXSelector,void*)
{
	dirty = 1;
	return 1;
}

// Update title
long MainWindow::onUpdTitle(FXObject*,FXSelector,void*)
{
	FXString title;
	if (curSpec.length() < 1)
		title = "Package Builder - noname.spec";
	else
		title = "Package Builder - " + curSpec;
	if (dirty || description->isModified() || prep_s->isModified() ||
			build_s->isModified() || install_s->isModified() || 
			clean_s->isModified()) { 
		
		dirty = 1;
		title += "*";
	}
	handle(this,MKUINT(FXWindow::ID_SETSTRINGVALUE,SEL_COMMAND),(void*)&title);
	return 1;
}

long MainWindow::onCmdFileAdd(FXObject*,FXSelector,void*)
{
	//FilesDlg id(this);
	InputDialog id(getApp());
	id.setTitle("Add File");
	if (id.execute()) {
		//filelist->appendItem(id.fname);		
		filelist->appendItem(id.input->getText());		
		dirty = 1;
	}
	return 1;
}

long MainWindow::onCmdFileDelete(FXObject*,FXSelector,void*)
{
	/*
	FXListItem **item;
	if (filelist->getNumSelectedItems()) {
		item = filelist->getSelectedItems();
		filelist->removeItem(item[0]);
		dirty = 1;
	}
	*/
	int i,num = filelist->getNumItems();
	for (i=0;i<num;i++) {
		if (filelist->isItemSelected(i)) {
			filelist->removeItem(i);
			dirty = 1;
			return 1;
		}
	}
	return 1;
}

long MainWindow::onUpdFileDelete(FXObject *source,FXSelector,void*)
{
	int i,num = filelist->getNumItems();
	for (i=0;i<num;i++) {
		if (filelist->isItemSelected(i)) {
			((FXButton*)source)->enable();
			return 1;
		}
	}
	((FXButton*)source)->disable();
	return 1;
}

long MainWindow::onCmdFileEdit(FXObject*,FXSelector,void*)
{
	int i,num = filelist->getNumItems();
	for (i=0;i<num;i++) {
		if (filelist->isItemSelected(i)) {
			InputDialog id(getApp());
			id.input->setText(filelist->getItemText(i));
			id.setTitle("Edit File");
			if (id.execute()) {
				filelist->setItemText(i,id.input->getText());
				dirty = 1;
			}
		}
	}
	return 1;
}

long MainWindow::onUpdFileEdit(FXObject *source,FXSelector,void*)
{
	int i,num = filelist->getNumItems();
	for (i=0;i<num;i++) {
		if (filelist->isItemSelected(i)) {
		((FXButton*)source)->enable();	
			return 1;
		}
	}
	((FXButton*)source)->disable();
	return 1;
}
void MainWindow::setClean()
{
	description->setModified(FALSE);
	prep_s->setModified(FALSE); 
	build_s->setModified(FALSE);
	install_s->setModified(FALSE);  
	clean_s->setModified(FALSE);
	dirty = 0;
}

long MainWindow::onCmdAdvanced(FXObject*,FXSelector,void*)
{
	int pos;
	if ((pos = advdlg->AsourceX.findf('\n')) == -1) //This is the only source
		advdlg->AsourceX = source->getText();
	else //multiple source use "source" as Source0
		advdlg->AsourceX = source->getText() + 
			advdlg->AsourceX.mid(pos,advdlg->AsourceX.length());
	advdlg->setData();
	if (advdlg->execute()) {
		advdlg->commitData();
		if ((pos = advdlg->AsourceX.findf('\n')) == -1) //This is the only source
			source->setText(advdlg->AsourceX);
		else //multiple source use "source" as Source0
			source->setText(advdlg->AsourceX.left(pos));
		dirty = 1;
	}
	
	return 1;
}

long MainWindow::onCmdScript(FXObject*,FXSelector script,void *ptr)
{
	switch (script) {
		case ID_M_PREP:
			tabbook->handle(this,MKUINT(FXTabBar::ID_OPEN_FIRST+1,SEL_COMMAND),ptr);
			break;
		case ID_M_BUILD:
			tabbook->handle(this,MKUINT(FXTabBar::ID_OPEN_FIRST+1,SEL_COMMAND),ptr);
			break;
		case ID_M_INSTALL:
			tabbook->handle(this,MKUINT(FXTabBar::ID_OPEN_FIRST+2,SEL_COMMAND),ptr);
			break;
		case ID_M_CLEAN:
			tabbook->handle(this,MKUINT(FXTabBar::ID_OPEN_FIRST+2,SEL_COMMAND),ptr);
			break;
		case ID_M_PRE:
			scriptDlg->setLabel("%pre: Script run before install.");
			scriptDlg->setText(pre_s);
			if (scriptDlg->execute()) {
				dirty = 1;
				pre_s = scriptDlg->getText();
			}
			break;
		case ID_M_POST:
			scriptDlg->setLabel("%post: Script run after install.");
			scriptDlg->setText(post_s);
			if (scriptDlg->execute()) {
				dirty = 1;
				post_s = scriptDlg->getText();
			}
			break;
		case ID_M_PREUN:
			scriptDlg->setLabel("%preun: Script run before uninstall.");
			scriptDlg->setText(preun_s);
			if (scriptDlg->execute()) {
				dirty = 1;
				preun_s = scriptDlg->getText();
			}
			break;
		case ID_M_POSTUN:
			scriptDlg->setLabel("%postun: Script run after uninstall.");
			scriptDlg->setText(postun_s);
			if (scriptDlg->execute()) {
				dirty = 1;
				postun_s = scriptDlg->getText();
			}
			break;
		case ID_M_CHANGELOG:
			scriptDlg->setLabel("%changelog: A log of changes to the SPEC file.");
			scriptDlg->setText(changelog);
			if (scriptDlg->execute()) {
				dirty = 1;
				changelog = scriptDlg->getText();
			}
			break;
		case ID_M_VERIFY:
			scriptDlg->setLabel("%verifyscript: Script run to verify package.");
			scriptDlg->setText(verify_s);
			if (scriptDlg->execute()) {
				dirty = 1;
				verify_s = scriptDlg->getText();
			}
			break;
	}
	return 1;
}

long MainWindow::onCmdClearTab(FXObject*,FXSelector,void*)
{
	int ret = tabbook->getCurrent();
	switch (ret) {
		case 0: //preamble
			summary->setText("");
			source->setText("");
			name->setText("");
			version->setText("");
			release->setText("");
			copyright->setText("");
			icon->setText("");
			description->setText("");
			break;
		case 1: //prep & build
			prep_s->setText("");
			build_s->setText("");
			break;
		case 2: //install & clean
			install_s->setText("");
			clean_s->setText("");
			break;
		case 3: //files
			filelist->clearItems();
			break;
		case 4: // compiler
			buildbox->setText("");
			break;
	}
	dirty = 1;
	return 1;
}

long MainWindow::onCmdClearAll(FXObject*,FXSelector,void*)
{
	clearLexStrings();
	LoadSpecData();
	dirty = 1;
	return 1;
}
