/********************************************************************************
* pkgbuild an X Windows RPM(C) SPEC file developemnt system	                    *
* Copyright (C) 2000 by Davin S. Hills.  All Rights Reserved.                   *
*********************************************************************************
* This program is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Library General Public                   *
* License as published by the Free Software Foundation; either                  *
* version 2 of the License, or (at your option) any later version.              *
*                                                                               *
* This program is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             *
* Library General Public License for more details.                              *
*                                                                               *
* You should have received a copy of the GNU Library General Public             *
* License along with this library; if not, write to the Free                    *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            *
********************************************************************************/
#include "fx.h"
#include "advanced.h"
#include "script.h"

// Mini application object
class MainWindow : public FXMainWindow {
		FXDECLARE(MainWindow)
protected:
	MainWindow() { }
	int fdout[2];
	FXTextField *summary,*source,*name,*version,*release,*copyright,*icon,*buildroot;
	FXComboBox *group;
	FXText *description, *prep_s;
	FXText *build_s,*install_s,*clean_s;
	FXString pre_s, post_s, preun_s, postun_s, changelog, verify_s;
	FXText *buildbox;
	FXTooltip *tooltip;
	FXTabBook *tabbook;
	FXHorizontalFrame *toolbar;		
	FXStatusbar *statusbar;
	FXMenuBar *menubar;
	FXList *filelist;
	FXString curSpec;
	FXint dirty;
	FXint test;
	FXString titleText;
	AdvancedDlg *advdlg;
	ScriptDlg *scriptDlg;

public:
	long onCmdExit(FXObject*,FXSelector,void*);
	long onCmdNew(FXObject*,FXSelector,void*);
	long onCmdOpen(FXObject*,FXSelector,void*);
	long onCmdSave(FXObject*,FXSelector,void*);
	long onCmdSaveAs(FXObject*,FXSelector,void*);
	long onCmdAbout(FXObject*,FXSelector,void*);
	long onCmdPrepOnly(FXObject*,FXSelector,void*);
	long onCmdListCheck(FXObject*,FXSelector,void*);
	long onCmdCompileOnly(FXObject*,FXSelector,void*);
	long onCmdInstallOnly(FXObject*,FXSelector,void*);
	long onCmdBinaryOnly(FXObject*,FXSelector,void*);
	long onCmdBuildAll(FXObject*,FXSelector,void*);
	long onCmdTest(FXObject*,FXSelector,void*);
	long onUpdTest(FXObject*,FXSelector,void*);
	long onCmdTrigger(FXObject*,FXSelector,void*);
	long onCmdChanged(FXObject*,FXSelector,void*);
	long onUpdTitle(FXObject*,FXSelector,void*);
	long onCmdFileAdd(FXObject*,FXSelector,void*);
	long onCmdFileDelete(FXObject*,FXSelector,void*);
	long onCmdFileEdit(FXObject*,FXSelector,void*);
	long onUpdFileEdit(FXObject *source,FXSelector,void*);
	long onUpdFileDelete(FXObject *source,FXSelector,void*);
	long onCmdAdvanced(FXObject*,FXSelector,void*);
	long onCmdScript(FXObject*,FXSelector script,void*);
	long onCmdClearTab(FXObject*,FXSelector,void*);
	long onCmdClearAll(FXObject*,FXSelector,void*);

	long onCmdMPrep(FXObject *source,FXSelector,void *ptr) { return onCmdScript(source,ID_M_PREP,ptr); }
	long onCmdMBuild(FXObject *source,FXSelector,void *ptr) { return onCmdScript(source,ID_M_BUILD,ptr); }
	long onCmdMInstall(FXObject *source,FXSelector,void *ptr) { return onCmdScript(source,ID_M_INSTALL,ptr); }
	long onCmdMClean(FXObject *source,FXSelector,void *ptr) { return onCmdScript(source,ID_M_CLEAN,ptr); }
	long onCmdMPre(FXObject *source,FXSelector,void *ptr) { return onCmdScript(source,ID_M_PRE,ptr); }
	long onCmdMPost(FXObject *source,FXSelector,void *ptr) { return onCmdScript(source,ID_M_POST,ptr); }
	long onCmdMPreun(FXObject *source,FXSelector,void *ptr) { return onCmdScript(source,ID_M_PREUN,ptr); }
	long onCmdMPostun(FXObject *source,FXSelector,void *ptr) { return onCmdScript(source,ID_M_POSTUN,ptr); }
	long onCmdMChangeLog(FXObject *source,FXSelector,void *ptr) { return onCmdScript(source,ID_M_CHANGELOG,ptr); }
	long onCmdMVerify(FXObject *source,FXSelector,void *ptr) { return onCmdScript(source,ID_M_VERIFY,ptr); }

	void LoadSpecData();
	void RunRPM_BuildCmd(FXString cmd);
	void fillGroups();
	FXString BuildSpecString();
	void setClean();
	int saveFile();
	
public:
	MainWindow(FXApp* a);
	virtual void create();
	enum{
		ID_EXIT=FXMainWindow::ID_LAST,
		ID_TEST,
		ID_PREPONLY,
		ID_LISTCHECK,
		ID_COMPILEONLY,
		ID_INSTALLONLY,
		ID_BINARYONLY,
		ID_BUILDALL,
		ID_SUMMARY,
		ID_NAME,
		ID_VERSION,
		ID_RELEASE,
		ID_COPYRIGHT,
		ID_GROUP,
		ID_ICON,
		ID_BUILDROOT,
		ID_ABOUT,
		ID_NEW,
		ID_OPEN,
		ID_SAVE,
		ID_SAVEAS,
		ID_FILE_ADD,
		ID_FILE_EDIT,
		ID_FILE_DELETE,
		ID_ADVANCED,
		ID_RESPONSE,
		ID_TRIGGER,
		ID_TITLE,
		ID_M_PREP,
		ID_M_BUILD,
		ID_M_INSTALL,
		ID_M_CLEAN,
		ID_M_PRE,
		ID_M_POST,
		ID_M_PREUN,
		ID_M_POSTUN,
		ID_M_CHANGELOG,
		ID_M_VERIFY,
		ID_CLEARTAB,
		ID_CLEARALL
	};

};

