%{
//#define STAND_ALONE
#define YY_NO_UNPUT
#include "fx.h"
#include <string.h>

extern int isatty (int __fd) __THROW;

FXString l_app,l_ver,l_rel,l_sum,l_descrip,l_copyright,l_group;
FXString l_prep,l_build,l_install,l_post,l_files;
FXString l_release, l_distribution, l_icon, l_vendor, l_url, l_packager;
FXString l_provides, l_requires, l_serial, l_autoreqprov, l_excludearch;
FXString l_exclusivearch, l_excludeos, l_exclusiveos, l_prefix;
FXString l_buildroot, l_nosource, l_nopatch;
FXString l_clean, l_pre, l_preun, l_postun, l_verifyscript, l_changelog;
FXString l_package, l_prereq;
FXString l_sourceX, l_patchX, l_defines;

void clearLexStrings()
{
	l_prereq.clear();
	l_app.clear();
	l_ver.clear();
	l_rel.clear();
	l_sum.clear();
	l_descrip.clear();
	l_copyright.clear();
	l_group.clear();
	l_prep.clear();
	l_build.clear();
	l_install.clear();
	l_post.clear();
	l_files.clear();
	l_release.clear();
	l_distribution.clear();
	l_icon.clear();
	l_vendor.clear();
	l_url.clear();
	l_packager.clear();
	l_provides.clear();
	l_requires.clear();
	l_serial.clear();
	l_autoreqprov.clear();
	l_excludearch.clear();
	l_exclusivearch.clear();
	l_excludeos.clear();
	l_exclusiveos.clear();
	l_prefix.clear();
	l_buildroot.clear();
	l_nosource.clear();
	l_nopatch.clear();
	l_clean.clear();
	l_pre.clear();
	l_preun.clear();
	l_postun.clear();
	l_verifyscript.clear();
	l_changelog.clear();
	l_package.clear();
	l_sourceX.clear();
	l_patchX.clear();
	l_defines.clear();
}

void lexTrim(FXString *tstr)
{
	if (tstr->length() < 1)
		return ;
	if ((tstr->left(1) == "\n") || (tstr->left(1) == " ") || (tstr->left(1) == "\t"))
		*tstr = tstr->mid(1,tstr->length()-1);
	if ((tstr->right(1) == "\n") || (tstr->right(1) == " ") || (tstr->right(1) == "\t"))
		*tstr = tstr->left(tstr->length()-1);
}

void cleanLexStrings()
{
	lexTrim(&l_prereq);
	lexTrim(&l_app);
	lexTrim(&l_ver);
	lexTrim(&l_rel);
	lexTrim(&l_sum);
	lexTrim(&l_descrip);
	lexTrim(&l_copyright);
	lexTrim(&l_group);
	lexTrim(&l_prep);
	lexTrim(&l_build);
	lexTrim(&l_install);
	lexTrim(&l_post);
	lexTrim(&l_files);
	lexTrim(&l_release);
	lexTrim(&l_distribution);
	lexTrim(&l_icon);
	lexTrim(&l_vendor);
	lexTrim(&l_url);
	lexTrim(&l_packager);
	lexTrim(&l_provides);
	lexTrim(&l_requires);
	lexTrim(&l_serial);
	lexTrim(&l_autoreqprov);
	lexTrim(&l_excludearch);
	lexTrim(&l_exclusivearch);
	lexTrim(&l_excludeos);
	lexTrim(&l_exclusiveos);
	lexTrim(&l_prefix);
	lexTrim(&l_buildroot);
	lexTrim(&l_nosource);
	lexTrim(&l_nopatch);
	lexTrim(&l_clean);
	lexTrim(&l_pre);
	lexTrim(&l_preun);
	lexTrim(&l_postun);
	lexTrim(&l_verifyscript);
	lexTrim(&l_changelog);
	lexTrim(&l_package);
	lexTrim(&l_sourceX);
	lexTrim(&l_patchX);
	lexTrim(&l_defines);
}

%}

%s SUMMARY
%s APPNAME
%s VERSION
%s RELEASE
%s COPYRIGHT
%s GROUP
%s SOURCE
%s DISTRIBUTION
%s ICON
%s VENDOR
%s URL
%s PACKAGER
%s PROVIDES
%s REQUIRES
%s PREREQ
%s SERIAL
%s AUTOREQPROV
%s EXCLUDEARCH
%s EXCLUSIVEARCH
%s EXCLUDEOS
%s EXCLUSIVEOS
%s PREFIX
%s BUILDROOT
%s NOSOURCE
%s PATCHNAME
%s NOPATCH
%s SOURCEX
%s PATCHX
%s DEFINE

%s DESCRIP
%s PREP
%s PATCH
%s BUILD
%s INSTALL
%s CLEAN
%s PRE
%s POST
%s PREUN
%s POSTUN
%s VERIFYSCRIPT
%s CHANGELOG
%s SETUP
%s FILES
%s DOC
%s CONFIG
%s ATTR
%s DEFATTR
%s VERIFY
%s DOCDIR
%s DIR
%s PACKAGE



%%
^Summary:[\t ]*			{ BEGIN SUMMARY;	}
^Name:[\t ]*			{ BEGIN APPNAME;	}
^Version:[\t ]*			{ BEGIN VERSION;	}
^Release:[\t ]*			{ BEGIN RELEASE;	}
^Copyright:[\t ]*		{ BEGIN COPYRIGHT;	}
^Group:[\t ]*			{ BEGIN GROUP;		}
^Distribution:[\t ]*	{ BEGIN DISTRIBUTION; }
^Icon:[\t ]*			{ BEGIN ICON;	    }
^Vendor:[\t ]*			{ BEGIN VENDOR;	    }
^URL:[\t ]*				{ BEGIN URL;	    }
^Packager:[\t ]*		{ BEGIN PACKAGER;   }
^Provides:[\t ]*		{ BEGIN PROVIDES;   }
^Requires:[\t ]*		{ BEGIN REQUIRES;   }
^Prereq:[\t ]*			{ BEGIN PREREQ;   }
^Serial:[\t ]*			{ BEGIN SERIAL;	    }
^AutoReqProv:[\t ]*		{ BEGIN AUTOREQPROV; }
^ExcludeArch:[\t ]*		{ BEGIN EXCLUDEARCH; }
^ExclusiveArch:[\t ]*	{ BEGIN EXCLUSIVEARCH; }
^ExcludeOS:[\t ]*		{ BEGIN EXCLUDEOS;  }
^ExclusiveOS:[\t ]*		{ BEGIN EXCLUSIVEOS; }
^Prefix:[\t ]*			{ BEGIN PREFIX;	    }
^BuildRoot:[\t ]*		{ BEGIN BUILDROOT;  }
^NoSource:[\t ]*		{ BEGIN NOSOURCE;   }
^NoPatch:[\t ]*			{ BEGIN NOPATCH;    }
^Source[0-9]*:[\t ]*	{ BEGIN SOURCEX;	}
^Patch[0-9]*:[\t ]*		{ BEGIN PATCHX;		}

^%define[\t ]*			{ BEGIN DEFINE;		}
^%description[\t ]*\n  	{ BEGIN DESCRIP;	}
^%prep					{ BEGIN PREP;		}
^%setup					{ BEGIN SETUP;		}
^%patch					{ BEGIN PATCH;		}
^%build					{ BEGIN BUILD;		}
^%install				{ BEGIN INSTALL;	}
^%clean					{ BEGIN CLEAN;		}
^%pre					{ BEGIN PRE;		}
^%post					{ BEGIN POST;		}
^%preun					{ BEGIN PREUN;		}
^%postun				{ BEGIN POSTUN;		}
^%verifyscript			{ BEGIN VERIFYSCRIPT; }
^%changelog				{ BEGIN CHANGELOG;	}
^%files					{ BEGIN FILES;		}
^%doc					{ BEGIN DOC;		}
^%config				{ BEGIN CONFIG;		}
^%attr					{ BEGIN ATTR;		}
^%defattr				{ BEGIN DEFATTR;	}
^%verify				{ BEGIN VERIFY;		}
^%docdir				{ BEGIN DOCDIR;		}
^%dir					{ BEGIN DIR;		}
^%package				{ BEGIN PACKAGE;	}

<SUMMARY>.*\n		{ BEGIN 0; l_sum += yytext; }
<APPNAME>.*\n		{ BEGIN 0; l_app += yytext; }
<VERSION>.*\n		{ BEGIN 0; l_ver += yytext; }
<RELEASE>.*\n		{ BEGIN 0; l_rel += yytext; }
<COPYRIGHT>.*\n		{ BEGIN 0; l_copyright += yytext; }
<GROUP>.*\n			{ BEGIN 0; l_group += yytext; }
<SOURCEX>.*\n		{ BEGIN 0; l_sourceX += yytext; }
<PATCHX>.*\n		{ BEGIN 0; l_patchX += yytext; }
<DISTRIBUTION>.*\n	{ BEGIN 0; l_distribution += yytext;  }
<ICON>.*\n			{ BEGIN 0; l_icon += yytext; }
<VENDOR>.*\n		{ BEGIN 0; l_vendor += yytext;   }
<URL>.*\n			{ BEGIN 0; l_url += yytext;  }
<PACKAGER>.*\n		{ BEGIN 0; l_packager += yytext;  }
<PROVIDES>.*\n		{ BEGIN 0; l_provides += yytext;  }
<REQUIRES>.*\n		{ BEGIN 0; l_requires += yytext;  }
<PREREQ>.*\n		{ BEGIN 0; l_prereq += yytext;  }
<SERIAL>.*\n		{ BEGIN 0; l_serial += yytext;  }
<AUTOREQPROV>.*\n	{ BEGIN 0; l_autoreqprov += yytext;  }
<EXCLUDEARCH>.*\n	{ BEGIN 0; l_excludearch += yytext;  }
<EXCLUSIVEARCH>.*\n	{ BEGIN 0; l_exclusivearch += yytext;  }
<EXCLUDEOS>.*\n		{ BEGIN 0; l_excludeos += yytext;  }
<EXCLUSIVEOS>.*\n	{ BEGIN 0; l_exclusiveos += yytext;  }
<PREFIX>.*\n		{ BEGIN 0; l_prefix += yytext;  }
<BUILDROOT>.*\n		{ BEGIN 0; l_buildroot += yytext;  }
<NOSOURCE>.*\n		{ BEGIN 0; l_nosource += yytext;  }
<NOPATCH>.*\n		{ BEGIN 0; l_nopatch += yytext;  }

<DEFINE>.*\n		{ BEGIN 0; l_defines += FXString(yytext) + "\n"; }
<DESCRIP>^%			{ BEGIN 0; }
<DESCRIP>.|\n		{ l_descrip += yytext; }
<BUILD>^%			{ BEGIN 0; }
<BUILD>.|\n			{ l_build += yytext; }
<FILES>^%			{ BEGIN 0; }
<FILES>.|\n			{ l_files += yytext; }
<DOC>.*\n			{ BEGIN FILES; l_files += FXString("%doc") + yytext; }
<CONFIG>.*\n		{ BEGIN FILES; l_files += FXString("%config") + yytext; }
<DIR>.*\n			{ BEGIN FILES; l_files += FXString("%dir") + yytext; } 
<DOCDIR>.*\n		{ BEGIN FILES; l_files += FXString("%docdir") + yytext; }
<ATTR>.*\n			{ BEGIN FILES; l_files += FXString("%attr") + yytext; }
<DEFATTR>.*\n		{ BEGIN FILES; l_files += FXString("%defattr") + yytext; }
<VERIFY>.*\n		{ BEGIN FILES; l_files += FXString("%verify") + yytext; }
<PREP>^%			{ BEGIN 0; }
<PREP>.|\n			{ l_prep += yytext; }
<SETUP>.*\n			{ BEGIN PREP; l_prep += FXString("%setup") + yytext; }
<PATCH>.*\n			{ BEGIN PREP; l_prep += FXString("%patch") + yytext; }
<INSTALL>^%			{ BEGIN 0; }
<INSTALL>.|\n		{ l_install += yytext; }
<CLEAN>^%			{ BEGIN 0; }
<CLEAN>.|\n			{ l_clean += yytext; }
<PRE>^%				{ BEGIN 0; }
<PRE>.|\n			{ l_pre += yytext; }
<POST>^%			{ BEGIN 0; }
<POST>.|\n			{ l_post += yytext; }
<PREUN>^%			{ BEGIN 0; }
<PREUN>.|\n			{ l_preun += yytext; }
<POSTUN>^%			{ BEGIN 0; }
<POSTUN>.|\n		{ l_postun += yytext; }
<VERIFYSCRIPT>^%	{ BEGIN 0; }
<VERIFYSCRIPT>.|\n	{ l_verifyscript += yytext; }
<CHANGELOG>^%		{ BEGIN 0; }
<CHANGELOG>.|\n		{ l_changelog += yytext; }
<PACKAGE>^%			{ BEGIN 0; }
<PACKAGE>.|\n		{ l_package += yytext; }

.	/* ignore anything else */ ;

%%
int yywrap()
{
	return 1;
}

#ifdef STAND_ALONE
main()
{
	FILE *file;
	file = fopen("apache.spec","r");
	if (!file) {
		fprintf(stderr,"Failed to open file\n");
		exit(1);
	}
	yyin = file;
	yylex();
	fclose(file);
	printf("Item:\n %s\n",l_app.text());
	printf("Item:\n %s\n",l_ver.text());
	printf("Item:\n %s\n",l_rel.text());
	printf("Item:\n %s\n",l_sum.text());
	printf("Item:\n %s\n",l_descrip.text());
	printf("Item:\n %s\n",l_copyright.text());
	printf("Item:\n %s\n",l_group.text());
	printf("Item:\n %s\n",l_prep.text());
	printf("Item:\n %s\n",l_build.text());
	printf("Item:\n %s\n",l_install.text());
	printf("Item:\n %s\n",l_post.text());
	printf("Item:\n %s\n",l_files.text());
	printf("Item:\n %s\n",l_release.text());
	printf("Item:\n %s\n",l_distribution.text());
	printf("Item:\n %s\n",l_icon.text());
	printf("Item:\n %s\n",l_vendor.text());
	printf("Item:\n %s\n",l_url.text());
	printf("Item:\n %s\n",l_packager.text());
	printf("Item:\n %s\n",l_provides.text());
	printf("Item:\n %s\n",l_requires.text());
	printf("Item:\n %s\n",l_serial.text());
	printf("Item:\n %s\n",l_autoreqprov.text());
	printf("Item:\n %s\n",l_excludearch.text());
	printf("Item:\n %s\n",l_exclusivearch.text());
	printf("Item:\n %s\n",l_excludeos.text());
	printf("Item:\n %s\n",l_exclusiveos.text());
	printf("Item:\n %s\n",l_prefix.text());
	printf("Item:\n %s\n",l_buildroot.text());
	printf("Item:\n %s\n",l_nosource.text());
	printf("Item:\n %s\n",l_nopatch.text());
	printf("Item:\n %s\n",l_clean.text());
	printf("Item:\n %s\n",l_pre.text());
	printf("Item:\n %s\n",l_preun.text());
	printf("Item:\n %s\n",l_postun.text());
	printf("Item:\n %s\n",l_verifyscript.text());
	printf("Item:\n %s\n",l_changelog.text());
	printf("Item:\n %s\n",l_package.text());
}
#endif

